require "tran/version"
require "tran/row_calculator"
require 'csv'
require 'ox'

class Tran
  include RowCalculator

  attr_reader :headers

  def self.transform(xml, options)
    new(xml, options).transform
  end

  def initialize(xml, options)
    @headers = options.fetch(:headers)
    @xml = xml
  end

  def transform
    CSV.generate(headers: true) do |csv|
      csv << headers.values
      calculated_rows.each do |row|
        csv << row
      end
    end
  end

  def document
    @document ||= Ox.parse(@xml)
  end

end
